import sys
import os
os.environ['CUDA_VISIBLE_DEVICES'] = "0"
import re
import json
import numpy as np
from scipy.stats import pearsonr
from operator import itemgetter
from collections import defaultdict
from config import CONFIG
import pickle
from model import AccuracyPredictionModelFull 
import more_helpers as helpers

CF=CONFIG[sys.argv[3]]

HIER=CF["HIER"]
SHAREW=CF["SHAREW"]
LSTMLAYERS = CF["LSTMLAYERS"]
POINTERS = CF["POINTERS"]
SENSES=CF["SENSES"]
DEP = CF["DEP"]




test = helpers.loadjmultiple(sys.argv[1])


runid = sys.argv[2]

with open("models/maintokenizer_"+runid+".pkl","rb") as f:
    to=pickle.load(f)

with open("models/reltokenizer_"+runid+".pkl","rb") as f:
    tor=pickle.load(f)
with open("models/aligntokenizer_"+runid+".pkl","rb") as f:
    toa=pickle.load(f)
with open("models/sensetokenizer_"+runid+".pkl","rb") as f:
    tos=pickle.load(f)
with open("models/orderedmetrics_"+runid+".pkl","rb") as f:
    order,order_rest=pickle.load(f)
testkeys = list(sorted(list(test.keys())))



testamrs,testsensesamr = helpers.remove_senses([test[key]["amr_lin"] for key in testkeys])

testamrs = helpers.clean_common(testamrs)

testdeps = helpers.clean_common(helpers.clean_deps([test[key]["dep_lin_no_ids"] for key in testkeys]))

if not DEP:
    testdeps = helpers.clean_common(helpers.clean_deps([" ".join(test[key]["tokens"]) for key in testkeys]))


testrelsamr = [test[key]["amrrels"] for key in testkeys]

testalignamr = [test[key]["amralign"] for key in testkeys]

testrelsdep = [test[key]["deprels"] for key in testkeys]

testaligndep = [test[key]["depalign"] for key in testkeys]

if not DEP:
    testaligndep = [" ".join([str(num) for num in list(range(0,len(test[key]["depalign"].split(" "))))]) for key in testkeys]

testdeps = to.to_id_seqs(testdeps)

testamrs = to.to_id_seqs(testamrs)

testrelsamr = tor.to_id_seqs(testrelsamr)

testrelsdep = tor.to_id_seqs(testrelsdep)

testalignamr = toa.to_id_seqs(testalignamr)

testaligndep = toa.to_id_seqs(testaligndep)

testsensesamr = tos.to_id_seqs(testsensesamr)

e = to.make_embedding()
ea = toa.make_embedding()
es = tos.make_embedding()
er = tor.make_embedding()


model = AccuracyPredictionModelFull(e,ea,es,er).return_instance(LSTMLAYERS=LSTMLAYERS,SENSES=SENSES,POINTERS=POINTERS,dim_input=128,dim_lstm=128)

model.load_weights('models/'+runid+'-model.h5')
print("predicting")

if HIER:
    testpreds = model.predict([testdeps,testaligndep,testrelsdep,testamrs,testalignamr,testrelsamr,testsensesamr])[0]
    testpredsrest = model.predict([testdeps,testaligndep,testrelsdep,testamrs,testalignamr,testrelsamr,testsensesamr])[1]
else:
    testpreds = model.predict([testdeps,testaligndep,testrelsdep,testamrs,testalignamr,testrelsamr,testsensesamr])

def round_and_format(nums):
    nums = " & ".join([str(round(x,2)) for x in nums])
    return nums

for i in range(len(testpreds)):
    key = testkeys[i]
    dic = {}
    for j,k in enumerate(range(0,len(order_rest)*3,3)):
        dic["AUX--->"+order_rest[int(k/3)]] = {"F1":testpredsrest[i,k+2],"R":testpredsrest[i,k+1],"P":testpredsrest[i,k]}
    for j,k in enumerate(range(0,len(order)*3,3)):
        dic["MAIN--->"+order[int(k/3)]] = {"F1":testpreds[i,k+2],"R":testpreds[i,k+1],"P":testpreds[i,k]}
    print(key,dic)
    





